%define major   2
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d

Name:           mimalloc
Version:        2.0.9
Release:        %mkrel 1
Summary:        A general purpose allocator with excellent performance
Group:          System/Libraries
License:        MIT
URL:            https://github.com/microsoft/mimalloc
Source0:        https://github.com/microsoft/mimalloc/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires:  cmake
BuildRequires:  gcc-c++

%description
mimalloc (pronounced "me-malloc") is a general purpose allocator with excellent
performance characteristics. Initially developed by Daan Leijen for the run-time
systems of the Koka and Lean languages.

mimalloc is a drop-in replacement for malloc and can be used in other programs
without code changes, for example, on dynamically linked ELF-based systems
(Linux, BSD, etc.) you can use it as:

LD_PRELOAD=%{_libdir}/libmimalloc.so  myprogram

%package -n %{libname}
Summary:        A general purpose allocator with excellent performance
Group:          System/Libraries

%description -n %{libname}
mimalloc (pronounced "me-malloc") is a general purpose allocator with excellent
performance characteristics. Initially developed by Daan Leijen for the run-time
systems of the Koka and Lean languages.

mimalloc is a drop-in replacement for malloc and can be used in other programs
without code changes, for example, on dynamically linked ELF-based systems
(Linux, BSD, etc.) you can use it as:

LD_PRELOAD=%{_libdir}/libmimalloc.so  myprogram

%package -n %{devname}
Summary:        Development headers and library for %name
Group:          Development/C
Requires:       %{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
Development headers and library for mimalloc.

%prep
%autosetup -p1
# Remove unneded binary from sources
rm -rf bin

%build
%cmake \
    -DMI_BUILD_OBJECT=OFF \
    -DMI_BUILD_STATIC=OFF \
    -DMI_BUILD_TESTS=OFF \
    -DMI_INSTALL_TOPLEVEL=ON \
    -DMI_OVERRIDE=OFF
%cmake_build

%install
%cmake_install

%files -n %{libname}
%license LICENSE
%doc readme.md
%{_libdir}/lib%{name}.so.%{major}{,.*}

%files -n %{devname}
%{_libdir}/lib%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/cmake/%{name}/
%{_includedir}/%{name}*.h


%changelog
* Sat Jan 21 2023 daviddavid <daviddavid> 2.0.9-1.mga9
+ Revision: 1934711
- new version: 2.0.9

* Wed Oct 05 2022 akien <akien> 2.0.6-1.mga9
+ Revision: 1894937
- Libify for Mageia, cleanup
- import mimalloc-2.0.6-2.fc37 from F37


* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.6-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Fri Apr 15 2022 Vasiliy Glazov <vascom2@gmail.com> - 2.0.6-1
- Update to 2.0.6

* Tue Feb 15 2022 Vasiliy Glazov <vascom2@gmail.com> - 2.0.5-1
- Update to 2.0.5

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> - 2.0.3-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Mon Nov 15 2021 Vasiliy Glazov <vascom2@gmail.com> - 2.0.3-1
- Update to 2.0.3

* Wed Sep 29 2021 Vasiliy Glazov <vascom2@gmail.com> - 2.0.2-2
- Clean spec to follow packaging guidelines

* Wed Sep 29 2021 Vasiliy Glazov <vascom2@gmail.com> - 2.0.2-1
- Initial packaging for Fedora
